# Find sock of the given color in the list of socks
def find_color(color,socks):
    for i in range(len(socks)):
        if socks[i] == color:
            return i
    return -1
        
    
# Find the paired socks in the list 'basket' by picking the first sock
# then searching the basket for a matching color. Report any orphaned
# socks by printing their colors.
def find_paired_socks(basket):
    pairs = []
    while len(basket) > 0:
        print("basket: "+str(basket))
        print("pairs:  "+str(pairs))
        print()
        sock = basket.pop(0)               # Remove the first sock from the basket
        location = find_color(sock,basket) # Find the location of a matching color
        if location == -1:                 # If no match is found, report the orphan
            print(sock + " is an orphaned sock") 
        else:
            print("Found matching sock "+sock+" at basket index "+str(location))
            basket.pop(location)           # Otherwise remove the matching sock
            pairs.append(sock)             # and add the pair to the list of pairs
    return pairs

# Some demo socks in a list and
basket = ["red","green","green","yellow","blue","red","blue","orange"]
print("--------------------------------------------------------------------------------")
print("Pairing socks using first algorithm");
paired_socks = find_paired_socks(basket)
print("Paired socks: "+str(paired_socks))

# A slightly better approach that keeps socks on the table
def find_paired_socks_faster(basket):
    pairs = []
    table = []
    while len(basket) > 0:
        print("basket: "+str(basket))
        print("table:  "+str(table))
        print("pairs:  "+str(pairs))
        print()

        sock = basket.pop(0)
        table_location = find_color(sock,table)
        if table_location == -1:
            table.append(sock)  # A new single sock
        else:
            print("Found matching sock "+sock+" at table index "+str(table_location))
            table.pop(table_location) # Found a pair
            pairs.append(sock)
    for sock in table:
        print(sock + " is an orphaned sock")
    return pairs

# Repeat of the demo
basket2 = ["red","green","green","yellow","blue","red","blue","orange"]
print("--------------------------------------------------------------------------------")
print("Pairing socks using second, faster algorithm");
paired_socks2 = find_paired_socks_faster(basket2)
print("Paired socks: "+str(paired_socks2))
